package cz.muni.fi.pb162.abstractclasses;

/**
 * Abstraktné triedy predstavujú čiastočne implementované triedy
 * Zvyčajne sú využívané na čiastočnú implementáciu rozhraní
 * Sú označené kľúčovým slovom abstract
 * Nie je možné vytvoriť ich inštanciu
 * Sú náhradou klasickej nadtriedy v prípade, že inštancia nadtriedy je pre nás zbytočná alebo niektoré metódy nejde v nadtriede implementovať
 * Príkladom abstraktnej triedy je trieda AbstractAnimal
 */
public class Demo {
    public static void main(String[] args) {
        // nie je možné vytvoríť inštanciu abstraktnej triedy
        Animal animal = new Sheep(1.7, 80); // po odkomentovani nebude možné skompilovať
        animal = new Dog(0.5, 20);
        System.out.println(animal.makeNoise());

    }
}
